	;Mine sweeper

[BITS 16]
[ORG 100h]

	jmp begin

MODE	db	0
CUR		dw	0
SIZX	db	8
SIZY	db	8
MAXX	EQU	16
MAXY	EQU	16
BOMBS	db	8

WNDX	db	16
WNDY	db	16
WNSX	db	8
WNSY	db	8
WNDB	db	' '
WNDTITLE	DB	'Miner',1,0

CURX	db	0
CURY	db	0

KAL		EQU	0x4B00
KAU		EQU	0x4800
KAR		EQU	0x4D00
KAD		EQU 0x5000
KSP		EQU	0x3920
KRE		EQU	0x1C0D

rnd		dw	0x18A9	;RandomSeed

MAP		times	MAXX*MAXY	DB	0
;MAP		db	0,0,0,0,0,0,0,0
;		db	0,9,0,9,0,0,0,0
;		db	0,0,0,0,0,0,0,0
;		db	0,0,9,0,9,9,0,0
;		db	0,0,0,9,0,0,0,0
;		db	0,0,0,9,0,0,0,0
;		db	0,0,0,0,0,9,0,0
;		db	0,0,0,0,0,0,0,0
MASK	times	MAXX*MAXY	DB	0
;MAP2	times 8*8 DB 0

ROBOT	times	MAXX*MAXY	DW	0xFFFF
ROBOTS	DW	0

begin:
	mov ah,0Fh
	int 10h
	mov [MODE],al
	mov ah,03h
	int 10h
	mov [CUR],cx

	mov ax,0002h
	int 10h
	mov ax,1112h
	int 10h
	mov ah,01h
	mov cx,0007h
	int 10h

	call wnd

	call newMap
	;call showMap
	;call inwndhome

	;call moveCursor

mainlop:
	xor ax,ax
	int 16h

	mov bp,JumpTable
jtlop:
	cmp word [bp],0
	jz	jtend
	cmp [bp],ax
	jnz	jtforward
	add bp,2
	call [bp]
	jmp short jtend
jtforward:
	add bp,4
	jmp short jtlop
jtend:

	jmp	short mainlop

moveCursor:
	mov dl,[CURX]
	add dl,[WNDX]
	inc dl
	mov dh,[CURY]
	add dh,[WNDY]
	inc dh
	call locate
	ret

JumpTable:
	dw	0x011B
	dw	Quit
	dw	0x1071
	dw	Quit
	dw	KAL
	dw	K_Left
	dw	KAU
	dw	K_Up
	dw	KAR
	dw	K_Right
	dw	KAD
	dw	K_Down
	dw	KSP
	dw	K_Space
	dw	KRE
	dw	K_Enter
	dw	0x1372	;'R'
	dw	R
	dw	0x316E	;'N'
	dw	newMap
	dw	0x2166	;'F'
	dw	cellFlag
	dw	0

Quit:
	pop ax
	jmp end

R:
	call genRand

	push ax
	movzx ax,[SIZX]
	movzx bx,[SIZY]
	mul bx
	mov bx,ax
	pop ax

	xor dx,dx
	div bx
	mov ax,dx
	xor dx,dx
	movzx bx,[SIZX]
	div bx

	mov dh,al

	mov [CURX],dl
	mov [CURY],dh
	call moveCursor
	ret

;R2:
;	push es
;	push cs
;	pop es
;	mov di,MAP2
;	mov cx,8*8
;	cld
;	xor al,al
;	rep stosb
;	pop es
;	mov cx,1000
;Rrep:
;	push cx
;	call genRand
;
;	push ax
;	movzx ax,[SIZX]
;	movzx bx,[SIZY]
;	mul bx
;	mov bx,ax
;	pop ax
;
;	xor dx,dx
;	div bx
;	mov ax,dx
;	xor dx,dx
;	movzx bx,[SIZX]
;	div bx
;
;	mov dh,al
;
;	mov bp,MAP2
;	call getPtr
;	inc byte [bp]
;	cmp byte [bp],10
;	jne NOTs
;	call showMap2
;	pop cx
;	mov cx,1
;	jmp short NOTsj
;NOTs:
;	pop cx
;NOTsj:
;	loop Rrep
;	ret

;showMap2:
;	call inwndhome
;
;	mov bp,MAP2
;
;	movzx cx,[SIZY]
;smlop2_y:
;	push cx
;
;	movzx cx,[SIZX]
;smlop2_x:
;	mov ah,0Eh
;	mov al,[bp]
;	add al,'0'
;	int 10h
;
;	inc bp
;
;	loop smlop2_x
;
;	call inwndcrlf
;
;	pop cx
;	loop smlop2_y
;
;	ret









K_Left:
	cmp byte [CURX],0
	je	LeftRet
	dec byte [CURX]
	call moveCursor
LeftRet:
	ret
K_Up:
	cmp byte [CURY],0
	je	UpRet
	dec byte [CURY]
	call moveCursor
UpRet:
	ret
K_Right:
	mov al,[SIZX]
	dec al
	cmp byte [CURX],al
	je	RightRet
	inc byte [CURX]
	call moveCursor
RightRet:
	ret
K_Down:
	mov al,[SIZY]
	dec al
	cmp byte [CURY],al
	je	DownRet
	inc byte [CURY]
	call moveCursor
DownRet:
	ret
K_Space:
	call getCurMaskPtr

	cmp byte [bp],0
	jne	opend
	mov byte [bp],1
opend:
	call showMap
	ret
getCurMaskPtr:
	mov dl,[CURX]
	mov dh,[CURY]
getMaskPtr:
	mov bp,MASK	;bp=map
	jmp short getPtr
getCurMapPtr:
	mov dl,[CURX]
	mov dh,[CURY]
getMapPtr:
	mov bp,MAP
getPtr:
	push ax
	push si

	push dx
	movzx ax,[SIZX]
	movzx si,dh
	mul si		;sizx*cury
	add bp,ax	;bp+=result above expr.
	pop dx

	movzx ax,dl
	add bp,ax	;bp+=curx

	pop si
	pop ax
	ret
K_Enter:	;DL,DH=Pos
	;PreINIT
	call getCurMaskPtr
	cmp byte [bp],0
	je	fillCheck2
	call beep	; Already opened
	ret
fillCheck2:
	call getCurMapPtr
	cmp byte [bp],0	;IsNullCell?
	je	fillOK
	jmp cellOpen
	ret
fillOK:
	;INIT:Point to RightSide,pushing DX
	mov bp,sp
	mov sp,ROBOT
	push bp
	mov si,sp

	mov dl,[CURX]
	mov dh,[CURY]
	call findRight

	push dx
fillop:
	cmp sp,si
	je	fillend
	pop dx
	call getMaskPtr
	cmp byte [bp],0
	jne fillop
	mov cx,dx

	call findLeft

	push cx
	push dx

	inc cl
filler:
	cmp dl,cl
	je	fillingend
	call getMaskPtr
	mov byte [bp],0xFF
	inc dl
	jmp short filler
fillingend:
	;call findLeft

	pop dx
	pop cx
	mov bx,dx

	cmp dh,0
	je	nofillup
	dec dh
	call fillud
	inc dh
nofillup:
	mov dx,bx

	mov al,[SIZY]
	dec al
	cmp dh,al
	je	nofilldown
	inc dh
	call fillud
	dec dh
nofilldown:

	jmp short fillop
fillend:
	pop sp

	;open 8way

	mov bp,MASK
	movzx ax,[SIZX]
	movzx cx,[SIZY]
	mul cx
	mov cx,ax
fillafter:
	cmp byte [bp],0xFF
	jne nofillafter

	call MaskToAX
	mov byte [bp],1

	push bp
	cmp ah,0
	je	SkipTop
	push ax
	dec ah
	push ax
	movzx ax,[SIZX]
	sub bp,ax
	pop ax
	call subfillafter
	pop ax
SkipTop:
	pop bp

	push bp
	push ax
	call subfillafter
	pop ax
	pop bp

	push bp
	push ax
	inc ah
	cmp ah,[SIZY]
	jae	SkipBottom
	push ax
	movzx ax,[SIZX]
	add bp,ax
	pop ax
	call subfillafter
SkipBottom:
	pop ax
	pop bp

nofillafter:
	inc bp
	loop fillafter

	call showMap

	ret
MaskToAX:
	mov ax,bp
	sub ax,MASK
	jmp short ToAX
MapToAX:
	mov ax,bp
	sub ax,MAP
ToAX:
	mov bl,[SIZX]
	div bl
	xchg ah,al
	ret

subfillafter:
	cmp al,0
	je	SkipLeft

	dec bp
	dec al
	call setActive
	inc bp
	inc al
SkipLeft:

	call setActive

	inc bp
	inc al
	cmp al,[SIZX]
	jae	SkipRight
	call setActive
SkipRight:
	ret
setActive:
	cmp byte [bp],0
	jne	alreadyActive
	mov byte [bp],1
alreadyActive:
	ret

cellOpen:
	call getCurMaskPtr
	mov byte [bp],1

	call getCurMapPtr
	cmp byte [bp],9
	jne	notBombd

	mov byte [bp],10
	call chkDisFlag
	mov al,1
	call setMask
	call showMap
	jmp short cellOpenend
notBombd:
	call showMap
	call chkCleared
	jcxz cellOK
	jmp short cellOpenend
cellOK:
	call beep
	call beep
	call beep
cellOpenend:
	ret
cellFlag:
	call getCurMaskPtr
	cmp byte [bp],1
	jne cFtoggle
	call beep
	ret
cFtoggle:
	xor byte [bp],2
	call showMap
	ret
chkDisFlag:
	movzx ax,[SIZX]
	movzx bx,[SIZY]
	mul bx
	mov cx,ax
	mov bp,MASK
	mov si,MAP
cDFlop:
	cmp byte [bp],2
	jne NotFlagged
	cmp byte [si],9
	je  cDFInBomb
	cmp byte [si],10
	je  cDFInBomb
	mov byte [si],11
	jmp short NotFlagged
cDFInBomb:
	mov byte [si],12
NotFlagged:
	inc bp
	inc si
	loop cDFlop
	ret
chkCleared:
	movzx ax,[SIZX]
	movzx bx,[SIZY]
	mul bx
	mov cx,ax
	mov bp,MASK
	mov si,MAP
cClop:
	cmp byte [si],9
	jae	cCInBomb
	cmp byte [bp],1
	je	cCIllegal
	jmp short cCSkip
cCInBomb:
	cmp byte [bp],1
	jne	cCIllegal
	jmp short cCSkip
cCIllegal:
	ret
cCSkip:
	inc bp
	inc si
	loop cDFlop
	ret






fillud:
	pop di
filludlop:
	cmp dl,cl
	ja	filludend
	mov bp,MAP
	call getPtr
	cmp byte [bp],0
	jne	nofillud
	call findRight
	push dx
nofillud:
	inc dl
	jmp short filludlop
filludend:
	push di
	ret






findRight:	;In: DL/DH=X/Y Ret:DL=RightX
	push bp

	mov al,[SIZX]
	;dec al
frlop:
	cmp dl,al
	je	frfound
	mov bp,MAP
	call getPtr
	cmp byte [bp],0
	jne	frfound
	inc dl
	jmp short frlop
frfound:
	dec dl
frend:

	pop bp
	ret

findLeft:	;In: DL/DH=X/Y Ret:DL=LeftX
	push bp
	; Nothing init
fllop:
	cmp dl,0xFF
	je	flend
	mov bp,MAP
	call getPtr
	cmp byte [bp],0
	jne	flfound
	dec dl
	jmp short fllop
flfound:
	; Nothing to do
flend:
	inc dl
	pop bp
	ret

genRand:
	push bx
	push dx
	mov ax,[rnd]

	mov bx,0x23
	mul bx

	shr ax,7;4
	and ax,1
	push ax
	mov ax,[rnd]
	shr ax,12;15
	and ax,1
	shl word [rnd],1
	pop bx
	xor ax,bx
	xor ax,[rnd]

	mov [rnd],ax
	pop dx
	pop bx
	ret

end:
	mov ah,0h
	mov al,[MODE]
	int 10h
	mov ah,01h
	mov cx,[CUR]
	int 10h

	mov ax,4C00h
	int 21h





newMap:
	call eraseMap
	call mkMap
	call calcMap

	call showMap
	db 0xcc
	ret
eraseMap:
	xor ax,ax
	mov di,MAP
	call eMsub
setMask:
	mov di,MASK
	call eMsub
	ret
eMsub:
	push ax
	movzx ax,[SIZX]
	movzx bx,[SIZY]
	mul bx
	mov cx,ax
	pop ax
	cld
	rep stosb
	ret
	
mkMap:
	movzx cx,[BOMBS]
mkmlop:
	call genRand

	push ax
	movzx ax,[SIZX]
	movzx bx,[SIZY]
	mul bx
	mov bx,ax
	pop ax
	xor dx,dx
	div bx

	mov ax,dx

	mov bp,MAP
	add bp,ax
	cmp byte [bp],0
	jne mkmlop
	mov byte [bp],9

	loop mkmlop
	ret
calcMap:
	movzx ax,[SIZX]
	movzx bx,[SIZY]
	mul bx
	mov cx,ax
	mov bp,MAP
cMlop:
	call MapToAX

	cmp byte [bp],9
	jne NotMine

	push ax
	push bp
	cmp ah,0
	je	cMSkipTop
	dec ah
	push ax
	movzx ax,[SIZX]
	sub bp,ax
	pop ax
	call cMsub
cMSkipTop:
	pop bp
	pop ax

	call cMsub

	push ax
	push bp
	inc ah
	push ax
	movzx ax,[SIZX]
	add bp,ax
	pop ax
	cmp ah,[SIZY]
	je	cMSkipBottom
	call cMsub
cMSkipBottom:
	pop bp
	pop ax
NotMine:

	inc bp
	loop cMlop
	ret

cMsub:
	cmp al,0
	je	cMInLeft
	dec al
	dec bp
	call cMIsMine
	inc bp
	inc al
cMInLeft:

	call cMIsMine

	inc al
	inc bp
	cmp al,[SIZX]
	je	cMInRight
	call cMIsMine
cMInRight:
	dec al
	dec bp
	ret

cMIsMine:
	cmp byte [bp],9
	jae cMThisIsMine
	inc byte [bp]
cMThisIsMine:
	ret

showMap:
	call inwndhome

	mov bp,MASK
	mov si,MAP

	movzx cx,[SIZY]
smlop_y:
	push cx

	movzx cx,[SIZX]
smlop_x:
	mov ah,0Eh
	mov al,0B1h
	cmp byte [bp],0
	je	sm_zero
	cmp byte [bp],2
	jne sm_notFlagged
	mov al,0xF1;E2
	jmp short sm_zero
sm_notFlagged:
	mov al,[si]
	cmp al,0
	jne	smnotZero
	mov al,' '
	jmp short sm_zero
smnotZero:
	cmp al,9
	jne	smnotNine
	mov al,'@'
	jmp short sm_zero
smnotNine:
	cmp al,10
	jne	smnotTen
	mov al,'*'
	jmp short sm_zero
smnotTen:
	cmp al,11
	jne	smnotHazure
	mov al,'X'
	jmp short sm_zero
smnotHazure:
	cmp al,12
	jne	smnotFlaged
	mov al,0xF1
	jmp short sm_zero
smnotFlaged:
	add al,'0'
sm_zero:
	int 10h

	inc bp
	inc si

	loop smlop_x

	call inwndcrlf

	pop cx
	loop smlop_y

	call moveCursor

	ret

wnd:
	mov dl,[WNDX]
	mov dh,[WNDY]
	call locate

	mov ax,0E00h+0D5h
	int 10h
	movzx cx,[WNSX]
wndtoplop_x:
		mov ax,0E00h+0CDh
		int 10h
		loop wndtoplop_x
	mov ax,0E00h+0B8h
	int 10h

	call wndcrlf

	movzx cx,[WNSY]
wndmidlop_y:
		mov ax,0E00h+0B3h
		int 10h
		push cx

		movzx cx,[WNSX]
		mov ah,0Eh
		mov al,[WNDB]
wndmidlop_x:
			int 10h
			loop wndmidlop_x
		pop cx
		mov ax,0E00h+0B3h
		int 10h

		call wndcrlf

		loop wndmidlop_y

	mov ax,0E00h+0D4h
	int 10h
	movzx cx,[WNSX]
wndbtmlop_x:
		mov ax,0E00h+0CDh
		int 10h
		loop wndbtmlop_x
	mov ax,0E00h+0BEh
	int 10h

	mov dl,[WNDX]
	mov dh,[WNDY]
	inc dl
	call locate
	mov ax,0EB5h
	int 10h
	mov si,WNDTITLE
	call puts
	mov ax,0EC6h
	int 10h
	call inwndcrlf

	ret
locate:	;DL=X DH=Y
	mov ah,02h
	mov bh,00h
	int 10h

	ret

getcurpos:	;ret: DL=X DH=Y
	push cx
	mov ah,03h
	mov bh,00h
	int 10h
	pop cx

	ret

crlf:
	mov ax,0E00h+0Dh
	int 10h
	mov ax,0E00h+0Ah
	int 10h
	ret

puts:
	mov al,[si]
	cmp al,0
	jz	puts_exit
	mov ah,0Eh
	int 10h
	inc si
	jmp short puts
puts_exit:
	ret

wndcrlf:
	call crlf
	call getcurpos
	mov dl,[WNDX]
	call locate
	ret

nextlocate:
	call getcurpos
	inc dl
	call locate
	ret

inwndcrlf:
	call wndcrlf
	call nextlocate
	ret

inwndhome:
	mov dl,[WNDX]
	mov dh,[WNDY]
	inc dl
	inc dh
	call locate
	ret

beep:
	pusha

	;beep set
	MOV AL,0B6h
	OUT 043h,AL
	MOV AX,4000	;hz?
	OUT 042h,AL
	MOV AL,AH
	OUT 042h,AL

	mov si,0
	call waitor

	;beep on
	IN AL,61h
	OR AL,00000011b;03h
	OUT 61h,AL

	mov si,2
	call waitor

	;beep off
	IN AL,61h
	AND AL,11111100b;0FCh
	OUT 61h,AL

	popa
	ret

waitor:
	push ax
	push bx
	push cx
	push dx

	xor ax,ax
	int 1Ah
	mov bx,dx
	xor cx,cx
waitor_lop:
	push cx
	xor ax,ax
	int 1Ah
	pop cx
	cmp bx,dx
	je	waitor_lop
	mov bx,dx
	inc cx
	cmp cx,si
	jbe waitor_lop

	pop dx
	pop cx
	pop bx
	pop ax

	ret

putnum:
	push ax
	mov al,ah
	shr al,4
	call puthex
	pop ax
	push ax
	mov al,ah
	and al,0x0F
	call puthex
	pop ax
	push ax
	shr al,4
	call puthex
	pop ax
	push ax
	and al,0x0F
	call puthex
	pop ax
	push ax
	mov ax,0E00h+','
	int 10h
	pop ax
	ret
puthex:
	add al,'0'
	cmp al,'9'
	jbe	ZeroNine
	add al,'A'-'9'
ZeroNine:
	mov ah,0Eh
	int 10h
	ret

;;DATA

BUF		times	MAXX*MAXY	db	0
